

import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
import scipy
import math
import statistics
import os
from sklearn.linear_model import LinearRegression
from scipy import stats

import statsmodels.api as sm
import statsmodels.formula.api as smf
from statsmodels.graphics.tsaplots import plot_acf
from statsmodels.graphics.tsaplots import plot_pacf

plt.rcParams['text.color'] = 'black'  # Set the text color to black
plt.rcParams['font.family'] = 'Times new roman'


os.getcwd()

#Data
data = pd.read_excel("main_data.xlsx")
data['date'] = pd.to_datetime(data['date'])

#Data manipulering
#data.iloc[871,4]=0.0039



data["incomeReturn"] = data["Carry"] + data["Rf"]
data["priceReturn"] = data["futucom"] - data["incomeReturn"] 

Indexes = data.copy()
Indexes.iloc[:,1:] = np.cumprod(Indexes.iloc[:, 1:]+1) 
data["tenyearreturn_futu"] = np.zeros(len(data))
data["tenyearreturn_spot"] = np.zeros(len(data))
data["tenyearincomereturn"] = np.zeros(len(data))
data["tenyearpriceReturn"] = np.zeros(len(data))


for i in range(len(data)-120+1):
    if i==0:
        data["tenyearreturn_futu"][i+120-1] = Indexes.futucom[i+120-1]-1
        data["tenyearreturn_spot"][i+120-1] = Indexes.spotcom[i+120-1]-1
        data["tenyearincomereturn"][i+120-1] = Indexes.incomeReturn[i+120-1]-1
        data["tenyearpriceReturn"][i+120-1] = Indexes.priceReturn[i+120-1]-1
    
        
    else:
        data["tenyearreturn_futu"][i+120-1] = Indexes.futucom[i+120-1]/Indexes.futucom[i-1]-1
        data["tenyearreturn_spot"][i+120-1] = Indexes.spotcom[i+120-1]/Indexes.spotcom[i-1]-1
        data["tenyearincomereturn"][i+120-1] = Indexes.incomeReturn[i+120-1]/Indexes.incomeReturn[i-1]-1
        data["tenyearpriceReturn"][i+120-1] = Indexes.priceReturn[i+120-1]/Indexes.priceReturn[i-1]-1




#Annulizing from ten year 

data["tenyearreturn_futu"] = (1+data["tenyearreturn_futu"])**(1/10)-1
data["tenyearreturn_spot"] = (1+data["tenyearreturn_spot"])**(1/10)-1
data["tenyearincomereturn"] = (1+data["tenyearincomereturn"])**(1/10)-1
data["tenyearpriceReturn"] = (1+data["tenyearpriceReturn"])**(1/10)-1



#
monthly_data = data.iloc[:, [0,5,6,13,14,15,20, 21]]
corr_monthly = monthly_data.corr()


###############
#10 year

tenyear_data = data.iloc[120-1:, [0,22, 23, 24, 25]]

corr_tenyear = tenyear_data.corr()


# figure 4.1

plt.plot(tenyear_data["date"], tenyear_data.iloc[:,1], color="#2E8B57", label = "Total", lw=1.5)
plt.plot(tenyear_data["date"], tenyear_data.iloc[:,2], color="#0072B2", label = "Price", lw= 1.5)
plt.plot(tenyear_data["date"], tenyear_data.iloc[:,3], color="#B22222", label = "Income", lw =1.5)
plt.rcParams["figure.figsize"] = (12,6)
plt.grid()
plt.yticks(fontsize = 16)
plt.xticks(fontsize = 16)
plt.ylabel('Annualized Return', fontsize = 16)
#plt.xlabel("Year", fontsize = 22)
plt.title('Rolling 10-year Annualized Return', fontsize = 26)
plt.legend(loc = "upper left", fontsize = 16)
plt.show()
