

import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
import scipy
import math
import statistics
import os
import seaborn as sns
import pandas as pd


os.getcwd()

#Data
data = pd.read_excel("main_data.xlsx")
data['date'] = pd.to_datetime(data['date'])
data["int_yearly_change"] = -data.infYearly.shift(1)+data.infYearly



#stats for excess returns of spot, futu, bond, equtiy, rf and 60/40
exReturns = data.iloc[:,[0,1,2,3,4]]
exReturns["60/40"] = 0.6 * exReturns["exequity"] + 0.4 * exReturns["exbond"]
exReturns["Fullscale"] = 0.235* exReturns["exfutucom"] + (1-0.235)* exReturns["60/40"]


data_to_sort = exReturns.copy()
#Looking at descriptive of quintiles of inflation månedlig 
data_to_sort = data_to_sort.join(data["infMonth"])
sort_infMonth = data_to_sort.sort_values("infMonth")
intervall = int(1750/10)
sort_infMonth_stat_1 = sort_infMonth[0:intervall].describe()

sort_infMonth_stat_2 = sort_infMonth[intervall:intervall*2].describe()

sort_infMonth_stat_3 = sort_infMonth[intervall*2:intervall*3].describe()

sort_infMonth_stat_4 = sort_infMonth[intervall*3:intervall*4].describe()

sort_infMonth_stat_5 = sort_infMonth[intervall*4:intervall*5].describe()

sort_infMonth_stat_6 = sort_infMonth[intervall*5:intervall*6].describe()

sort_infMonth_stat_7 = sort_infMonth[intervall*6:intervall*7].describe()

sort_infMonth_stat_8 = sort_infMonth[intervall*7:intervall*8].describe()

sort_infMonth_stat_9 = sort_infMonth[intervall*8:intervall*9].describe()

sort_infMonth_stat_10 = sort_infMonth[intervall*9:].describe()


table_infMonth_quintile = pd.DataFrame(columns=['1', "2", "3",'4','5', "6", "7", "8", "9", "10"])
table_infMonth_quintile.loc["infMonth mean"] = [sort_infMonth_stat_1["infMonth"][1],sort_infMonth_stat_2["infMonth"][1],sort_infMonth_stat_3["infMonth"][1],sort_infMonth_stat_4["infMonth"][1],sort_infMonth_stat_5["infMonth"][1], sort_infMonth_stat_6["infMonth"][1], sort_infMonth_stat_7["infMonth"][1], sort_infMonth_stat_8["infMonth"][1], sort_infMonth_stat_9["infMonth"][1], sort_infMonth_stat_10["infMonth"][1]]

table_infMonth_quintile.loc["60/40 mean"] = [sort_infMonth_stat_1["60/40"][1],sort_infMonth_stat_2["60/40"][1],sort_infMonth_stat_3["60/40"][1],sort_infMonth_stat_4["60/40"][1],sort_infMonth_stat_5["60/40"][1], sort_infMonth_stat_6["60/40"][1], sort_infMonth_stat_7["60/40"][1], sort_infMonth_stat_8["60/40"][1], sort_infMonth_stat_9["60/40"][1], sort_infMonth_stat_10["60/40"][1]]
table_infMonth_quintile.loc["Fullscale mean"] = [sort_infMonth_stat_1["Fullscale"][1],sort_infMonth_stat_2["Fullscale"][1],sort_infMonth_stat_3["Fullscale"][1],sort_infMonth_stat_4["Fullscale"][1],sort_infMonth_stat_5["Fullscale"][1], sort_infMonth_stat_6["Fullscale"][1], sort_infMonth_stat_7["Fullscale"][1], sort_infMonth_stat_8["Fullscale"][1], sort_infMonth_stat_9["Fullscale"][1], sort_infMonth_stat_10["Fullscale"][1]]


## plot månedlig

inflation_quintile_plot_månedlig = table_infMonth_quintile.transpose()

# Create a figure and axis object
fig, ax = plt.subplots(figsize=(12, 6))
plt.rcParams['font.family'] = 'Times New Roman'
# Set the width of each bar
bar_width = 0.15

# Create a numpy array of the x-axis values
x = np.arange(len(inflation_quintile_plot_månedlig.index))

# Define the colors for each asset
colors = ['#00897B', '#F44336', '#FFC107', '#37474F', '#3F51B5']
colors = ['#FFC107', '#37474F', '#3F51B5']
#colors = ['#FFC107','#FFC107', '#3F51B5']

# Plot the bars for each asset with the appropriate color
ax.bar(x - bar_width, inflation_quintile_plot_månedlig['Fullscale mean'], width=bar_width, label='Fullscale portfolio', edgecolor='black', linewidth=0.5, color="red")
ax.bar(x , inflation_quintile_plot_månedlig['60/40 mean'], width=bar_width, label='60/40 portfolio', edgecolor='black', linewidth=0.5, color=colors[1])

# Add labels and title
ax.set_xlabel('Quantiles', fontsize=18, )
ax.set_ylabel('Mean Return', fontsize=18)
ax.set_title('Mean Returns Conditional on Inflation Level', fontsize=26)

# Set the x-axis ticks and tick labels
ax.set_xticks(x)
ax.set_xticklabels(inflation_quintile_plot_månedlig.index, fontsize=16)

# Set the y-axis ticks and tick labels
ax.tick_params(axis='y', labelsize=16)

# Add a legend
#plt.legend(fontsize=14, loc='left')
legend_font = {'family': 'Times New Roman', 'size': 14}
ax.legend(fontsize=14, prop=legend_font, loc = "upper left")

#ax.legend(fontsize=14)

# Set the background color to light grey and add a grid
#ax.set_facecolor('#F1F1F1')
#ax.grid(color='white', linestyle='--', linewidth=0.5)

# Set the figure size and save the plot to a file
#fig.set_size_inches(8, 6)
#fig.savefig('Portfolio_inf_quantiles_mean_MONTHLYreturn.png', dpi=300, bbox_inches='tight')

# Show the plot
plt.show()