

import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
import scipy
import math
import statistics
import os


os.getcwd()

#Data
data = pd.read_excel("main_data.xlsx")
data['date'] = pd.to_datetime(data['date'])

#Data manipulering
#data.iloc[871,4]=0.0039

#stats for excess returns of spot, futu, bond, equtiy, rf and 60/40
exReturns = data.iloc[:,[0,1,2,3,4]]
exReturns["60/40"] = 0.6 * exReturns["exequity"] + 0.4 * exReturns["exbond"]
exReturns["60/40_235Futu"] = 0.765 * exReturns["60/40"] + 0.235 * exReturns["exfutucom"]

#####################################################################################
#Like as above just with LN returns
#stats for LNexcess returns of spot, futu, bond, equtiy, rf and 60/40


LNexReturns = data.iloc[:,[0,1,2,3,4]]
LNexReturns["60/40"] = 0.6 * LNexReturns["exequity"] + 0.4 * LNexReturns["exbond"]
LNexReturns["60/40_235Futu"] = 0.765 * LNexReturns["60/40"] + 0.235 * LNexReturns["exfutucom"]

############################################################################
#Indekser:

Indexes = exReturns.copy()
Indexes.iloc[:,1:] = np.cumprod(Indexes.iloc[:, 1:]+1)

plt.plot(Indexes["date"], Indexes.iloc[:,5])
plt.plot(Indexes["date"], Indexes.iloc[:,6])

plt.show()


logIndexes = LNexReturns.copy()
logIndexes.iloc[:,1:] = np.cumsum(logIndexes.iloc[:, 1:])

# Create a figure and axis object
fig, ax = plt.subplots(figsize=(12, 6))
plt.rcParams['font.family'] = 'Times New Roman'

# Define the colors for each line
colors = ['#f44336', '#3f51b5', '#009688', '#ff9800']
colors = ['#00897B', '#F44336', '#FFC107', '#37474F', '#3F51B5']
colors = ['#FFC107', '#37474F', '#3F51B5']
#colors = ['#3F51B5', '#F44336', '#FF9800', '#4CAF50']
# Define the colors for each line
#colors = ['#1f77b4', '#d62728', '#2ca02c', '#9467bd']


# Plot the data with different colors and labels
ax.plot(logIndexes["date"], logIndexes.iloc[:,6], color="red", label='Fullscale')
ax.plot(logIndexes["date"], logIndexes.iloc[:,5], color=colors[1], label='60/40')



# Add grid lines and set the background color
ax.grid(True, color='lightgray', linestyle='-', linewidth=0.5)
fig.set_facecolor('white')

# Add axis labels and a title
ax.set_xlabel('Year', fontsize=18)
ax.set_ylabel('Wealth', fontsize=18)
ax.set_title('Cumulative Log Returns', fontsize=22)

ax.tick_params(axis='both', labelsize=16)

# Set the tick labels
#ax.set_xticklabels(logIndexes["date"].dt.strftime('%Y-%m-%d'), rotation=45, ha='right')

#ax.tick_params(axis='both', which='major', labelsize=10)

# Add a legend
#fig.set_size_inches(8, 6)

ax.legend(loc='upper left', fontsize=16)

# Display the plot
plt.show()

###############
#plot
plt.rcParams['text.color'] = 'black'  # Set the text color to black
plt.rcParams['font.family'] = 'Times new roman'
plt.rcParams["figure.figsize"] = (12,6)

colors = ['#FFC107', '#37474F', '#3F51B5']
plt.plot(logIndexes["date"], logIndexes.iloc[:,6], color="red", label='Fullscale')
plt.plot(logIndexes["date"], logIndexes.iloc[:,5], color=colors[1], label='60/40')
plt.grid()
plt.yticks(fontsize = 16)
plt.xticks(fontsize = 16)
plt.ylabel('Wealth', fontsize = 18)
#plt.xlabel("Year", fontsize = 22)
plt.title('Cumulative Log Returns', fontsize = 26)
plt.legend(loc = "upper left", fontsize = 16)
plt.show()