
import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
import scipy
import math
import statistics
import os

# Run full code for cumulative log returns plot. 


os.getcwd()

#Data
data = pd.read_excel("main_data.xlsx")
data['date'] = pd.to_datetime(data['date'])

#Data manipulering
#data.iloc[871,4]=0.0039

#stats for excess returns of spot, futu, bond, equtiy, rf and 60/40
exReturns = data.iloc[:,[0,1,2,3,4]]
exReturns["60/40"] = 0.6 * exReturns["exequity"] + 0.4 * exReturns["exbond"]
exReturns["60/40_5Futu"] = 0.95 * exReturns["60/40"] + 0.05 * exReturns["exfutucom"]
exReturns["60/40_10Futu"] = 0.90 * exReturns["60/40"] + 0.10 * exReturns["exfutucom"]
exReturns["60/40_20Futu"] = 0.80 * exReturns["60/40"] + 0.20 * exReturns["exfutucom"]
exReturns["60/40_30Futu"] = 0.70 * exReturns["60/40"] + 0.30 * exReturns["exfutucom"]
exReturns["60/40_18Futu"] = 0.82 * exReturns["60/40"] + 0.18 * exReturns["exfutucom"]
exReturns["60/40_48Futu"] = 0.52 * exReturns["60/40"] + 0.48 * exReturns["exfutucom"]
exReturns["28v46v26"] = 0.4588 * exReturns["exbond"] + 0.26 * exReturns["exfutucom"] + 0.2812 * exReturns["exequity"]
exReturns["84v0v16"] = 0.16 * exReturns["exfutucom"] + 0.84 * exReturns["exequity"]
exReturns["57v13v30"] = 0.126 * exReturns["exbond"] + 0.30 * exReturns["exfutucom"] + 0.574 * exReturns["exequity"]
exReturns["60/40_235Futu"] = 0.765 * exReturns["60/40"] + 0.235 * exReturns["exfutucom"]



exReturns = exReturns.join(data["Rf"])

exStats = exReturns.describe()
exStats.loc["mean"] = exStats.loc["mean"]*12
exStats.loc["std"] = exStats.loc["std"]*np.sqrt(12)
exStats.loc["SR"] = exStats.iloc[1]/exStats.iloc[2]

exStats.loc["skew"] = exReturns.skew()
exStats.loc["excessKurtosis"] = exReturns.kurtosis()

#stats for excess returns of spot, futu, bond, equtiy, rf and 60/40: Befor 1945
exReturns1877_1945 = data.iloc[0:826,[0,1,2,3,4]]
exReturns1877_1945["60/40"] = 0.6 * exReturns1877_1945["exequity"] + 0.4 * exReturns1877_1945["exbond"]
exReturns1877_1945["60/40_5Futu"] = 0.95 * exReturns1877_1945["60/40"] + 0.05 * exReturns1877_1945["exfutucom"]
exReturns1877_1945["60/40_10Futu"] = 0.90 * exReturns1877_1945["60/40"] + 0.10 * exReturns1877_1945["exfutucom"]
exReturns1877_1945["60/40_20Futu"] = 0.80 * exReturns1877_1945["60/40"] + 0.20 * exReturns1877_1945["exfutucom"]
exReturns1877_1945["60/40_30Futu"] = 0.70 * exReturns1877_1945["60/40"] + 0.30 * exReturns1877_1945["exfutucom"]

exReturns1877_1945 = exReturns1877_1945.join(data["Rf"])

exStats1877_1945 = exReturns1877_1945.describe()
exStats1877_1945.loc["mean"] = (exStats1877_1945.loc["mean"]+1)**12-1
exStats1877_1945.loc["std"] = exStats1877_1945.loc["std"]*np.sqrt(12)
exStats1877_1945.loc["SR"] = exStats1877_1945.iloc[1]/exStats1877_1945.iloc[2]


exStats1877_1945.loc["skew"] = exReturns1877_1945.skew()
exStats1877_1945.loc["excessKurtosis"] = exReturns1877_1945.kurtosis()

#stats for excess returns of spot, futu, bond, equtiy, rf and 60/40: from 1946 present
exReturns1946_2022 = data.iloc[827:,[0,1,2,3,4]]
exReturns1946_2022["60/40"] = 0.6 * exReturns1946_2022["exequity"] + 0.4 * exReturns1946_2022["exbond"]
exReturns1946_2022["60/40_5Futu"] = 0.95 * exReturns1946_2022["60/40"] + 0.05 * exReturns1946_2022["exfutucom"]
exReturns1946_2022["60/40_10Futu"] = 0.90 * exReturns1946_2022["60/40"] + 0.10 * exReturns1946_2022["exfutucom"]
exReturns1946_2022["60/40_20Futu"] = 0.80 * exReturns1946_2022["60/40"] + 0.20 * exReturns1946_2022["exfutucom"]
exReturns1946_2022["60/40_30Futu"] = 0.70 * exReturns1946_2022["60/40"] + 0.30 * exReturns1946_2022["exfutucom"]

exReturns1946_2022 = exReturns1946_2022.join(data["Rf"])

exStats1946_2022 = exReturns1946_2022.describe()
exStats1946_2022.loc["mean"] = (exStats1946_2022.loc["mean"]+1)**12-1
exStats1946_2022.loc["std"] = exStats1946_2022.loc["std"]*np.sqrt(12)
exStats1946_2022.loc["SR"] = exStats1946_2022.iloc[1]/exStats1946_2022.iloc[2]


exStats1946_2022.loc["skew"] = exReturns1946_2022.skew()
exStats1946_2022.loc["excessKurtosis"] = exReturns1946_2022.kurtosis()

#####################################################################################
#Like as above just with LN returns
#stats for LNexcess returns of spot, futu, bond, equtiy, rf and 60/40


LNexReturns = data.iloc[:,[0,1,2,3,4]]
LNexReturns["60/40"] = 0.6 * LNexReturns["exequity"] + 0.4 * LNexReturns["exbond"]
LNexReturns["60/40_5Futu"] = 0.95 * LNexReturns["60/40"] + 0.05 * LNexReturns["exfutucom"]
LNexReturns["60/40_10Futu"] = 0.90 * LNexReturns["60/40"] + 0.10 * LNexReturns["exfutucom"]
LNexReturns["60/40_20Futu"] = 0.80 * LNexReturns["60/40"] + 0.20 * LNexReturns["exfutucom"]
LNexReturns["60/40_30Futu"] = 0.70 * LNexReturns["60/40"] + 0.30 * LNexReturns["exfutucom"]
LNexReturns["60/40_18Futu"] = 0.82 * LNexReturns["60/40"] + 0.18 * LNexReturns["exfutucom"]
LNexReturns["60/40_48Futu"] = 0.52 * LNexReturns["60/40"] + 0.48 * LNexReturns["exfutucom"]
LNexReturns["28v46v26"] = 0.4588 * LNexReturns["exbond"] + 0.26 * LNexReturns["exfutucom"] + 0.2812 * LNexReturns["exequity"]
LNexReturns["84v0v16"] = 0.16 * LNexReturns["exfutucom"] + 0.84 * LNexReturns["exequity"]
LNexReturns["57v13v30"] = 0.126 * LNexReturns["exbond"] + 0.30 * LNexReturns["exfutucom"] + 0.574 * LNexReturns["exequity"]
LNexReturns["60/40_235Futu"] = 0.765 * LNexReturns["60/40"] + 0.235 * LNexReturns["exfutucom"]

LNexReturns = LNexReturns.join(data["Rf"])

LNexReturns.iloc[:, 1:] = np.log(LNexReturns.iloc[:, 1:]+1)

LNexStats = LNexReturns.describe()
LNexStats.loc["mean"] = LNexStats.loc["mean"]*12
LNexStats.loc["std"] = LNexStats.loc["std"]*np.sqrt(12)
LNexStats.loc["SR"] = LNexStats.iloc[1]/LNexStats.iloc[2]

LNexStats.loc["skew"] = LNexReturns.skew()
LNexStats.loc["excessKurtosis"] = LNexReturns.kurtosis()

#stats for LNexcess returns of spot, futu, bond, equtiy, rf and 60/40: Befor 1945
LNexReturns1877_1945 = data.iloc[0:826,[0,1,2,3,4]]
LNexReturns1877_1945["60/40"] = 0.6 * LNexReturns1877_1945["exequity"] + 0.4 * LNexReturns1877_1945["exbond"]
LNexReturns1877_1945["60/40_5Futu"] = 0.95 * LNexReturns1877_1945["60/40"] + 0.05 * LNexReturns1877_1945["exfutucom"]
LNexReturns1877_1945["60/40_10Futu"] = 0.90 * LNexReturns1877_1945["60/40"] + 0.10 * LNexReturns1877_1945["exfutucom"]
LNexReturns1877_1945["60/40_20Futu"] = 0.80 * LNexReturns1877_1945["60/40"] + 0.20 * LNexReturns1877_1945["exfutucom"]
LNexReturns1877_1945["60/40_30Futu"] = 0.70 * LNexReturns1877_1945["60/40"] + 0.30 * LNexReturns1877_1945["exfutucom"]

LNexReturns1877_1945 = LNexReturns1877_1945.join(data["Rf"])

LNexStats1877_1945 = LNexReturns1877_1945.describe()
LNexStats1877_1945.loc["mean"] = LNexStats1877_1945.loc["mean"]*12
LNexStats1877_1945.loc["std"] = LNexStats1877_1945.loc["std"]*np.sqrt(12)
LNexStats1877_1945.loc["SR"] = LNexStats1877_1945.iloc[1]/LNexStats1877_1945.iloc[2]


LNexStats1877_1945.loc["skew"] = LNexReturns1877_1945.skew()
LNexStats1877_1945.loc["excessKurtosis"] = LNexReturns1877_1945.kurtosis()

#stats for LNexcess returns of spot, futu, bond, equtiy, rf and 60/40: from 1946 present
LNexReturns1946_2022 = data.iloc[827:,[0,1,2,3,4]]
LNexReturns1946_2022["60/40"] = 0.6 * LNexReturns1946_2022["exequity"] + 0.4 * LNexReturns1946_2022["exbond"]
LNexReturns1946_2022["60/40_5Futu"] = 0.95 * LNexReturns1946_2022["60/40"] + 0.05 * LNexReturns1946_2022["exfutucom"]
LNexReturns1946_2022["60/40_10Futu"] = 0.90 * LNexReturns1946_2022["60/40"] + 0.10 * LNexReturns1946_2022["exfutucom"]
LNexReturns1946_2022["60/40_20Futu"] = 0.80 * LNexReturns1946_2022["60/40"] + 0.20 * LNexReturns1946_2022["exfutucom"]
LNexReturns1946_2022["60/40_30Futu"] = 0.70 * LNexReturns1946_2022["60/40"] + 0.30 * LNexReturns1946_2022["exfutucom"]

LNexReturns1946_2022 = LNexReturns1946_2022.join(data["Rf"])

LNexStats1946_2022 = LNexReturns1946_2022.describe()
LNexStats1946_2022.loc["mean"] = LNexStats1946_2022.loc["mean"]*12
LNexStats1946_2022.loc["std"] = LNexStats1946_2022.loc["std"]*np.sqrt(12)
LNexStats1946_2022.loc["SR"] = LNexStats1946_2022.iloc[1]/LNexStats1946_2022.iloc[2]


LNexStats1946_2022.loc["skew"] = LNexReturns1946_2022.skew()
LNexStats1946_2022.loc["excessKurtosis"] = LNexReturns1946_2022.kurtosis()



############################################################################
#Indekser:

Indexes = exReturns.copy()
Indexes.iloc[:,1:] = np.cumprod(Indexes.iloc[:, 1:]+1)

plt.plot(Indexes["date"], Indexes.iloc[:,1])
plt.plot(Indexes["date"], Indexes.iloc[:,3])
plt.plot(Indexes["date"], Indexes.iloc[:,5])
plt.plot(Indexes["date"], Indexes.iloc[:,15])
plt.show()


logIndexes = LNexReturns.copy()
logIndexes.iloc[:,1:] = np.cumsum(logIndexes.iloc[:, 1:])

# make plot
"""
fig, ax = plt.subplots(figsize=(12, 6))

# Define the colors for each line
colors = ['#f44336', '#3f51b5', '#009688', '#ff9800']
colors = ['#00897B', '#F44336', '#FFC107', '#37474F', '#3F51B5']



# Define the colors for each line
#colors = [(0, 128/255, 123/255), (196/255, 30/255, 58/255), (0, 66/255, 134/255), (255/255, 153/255, 70/255)]
#colors = ['#00897B', '#F44336','#3f85f5', '#ff8c00']
colors = ['#00897B', '#F44336','#3f85f5', '#37474F']

# Plot the data with equal line width and adjusted color brightness
ax.plot(logIndexes["date"], logIndexes.iloc[:, 1], color=colors[0], linewidth=1.5, label='Commodity Futures')
ax.plot(logIndexes["date"], logIndexes.iloc[:, 3], color=colors[1], linewidth=1.5, label='Stocks')
ax.plot(logIndexes["date"], logIndexes.iloc[:, 4], color=colors[2], linewidth=1.5, label='Bonds')
ax.plot(logIndexes["date"], logIndexes.iloc[:, 5], color=colors[3], linewidth=1.5, label='60/40')

# Add grid lines and set the background color
ax.grid(True, color='lightgray', linestyle='-', linewidth=0.5)
fig.set_facecolor('white')

# Add axis labels and a title
ax.set_xlabel('Year', fontsize=16, fontdict={'family': 'Times New Roman',  'size': 16})
ax.set_ylabel('Wealth', fontsize=16, fontdict={'family': 'Times New Roman',  'size': 26})
ax.set_title('Cumulative Log Returns', fontsize=26, fontdict={'family': 'Times New Roman',  'size': 26})

ax.tick_params(axis='both', labelsize=16, fontdict = "Times new roman")


# Set the tick labels font
#ax.set_xticklabels(ax.get_xticklabels(), fontdict={'family': 'Times New Roman', 'size': 12})
#ax.set_yticklabels(ax.get_yticklabels(), fontdict={'family': 'Times New Roman', 'size': 12})

# Add a legend with Times New Roman font
legend_font = {'family': 'Times New Roman', 'size': 16}
ax.legend(loc='best', fontsize=16, prop=legend_font)

plt.show()
"""
###############
#plot
plt.rcParams['text.color'] = 'black'  # Set the text color to black
plt.rcParams['font.family'] = 'Times new roman'
plt.rcParams["figure.figsize"] = (12,6)

colors = ['#00897B', '#F44336','#3f85f5', '#37474F']

plt.plot(logIndexes["date"], logIndexes.iloc[:, 1], color=colors[0], linewidth=1.5, label='Commodity Futures')
plt.plot(logIndexes["date"], logIndexes.iloc[:, 3], color=colors[1], linewidth=1.5, label='Stocks')
plt.plot(logIndexes["date"], logIndexes.iloc[:, 4], color=colors[2], linewidth=1.5, label='Bonds')
plt.plot(logIndexes["date"], logIndexes.iloc[:, 5], color=colors[3], linewidth=1.5, label='60/40')

plt.grid()
plt.yticks(fontsize = 16)
plt.xticks(fontsize = 16)
plt.ylabel('Wealth', fontsize = 18)
#plt.xlabel("Year", fontsize = 22)
plt.title('Cumulative Log Returns', fontsize = 26)
plt.legend(loc = "upper left", fontsize = 16)
plt.show()

