
import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
import scipy
import math
import statistics
import os
import seaborn as sns
import pandas as pd


os.getcwd()

#Data
data = pd.read_excel("main_data.xlsx")
data['date'] = pd.to_datetime(data['date'])
data["int_yearly_change"] = -data.infYearly.shift(1)+data.infYearly



#stats for excess returns of spot, futu, bond, equtiy, rf and 60/40
exReturns = data.iloc[:,[0,1,2,3,4]]
exReturns["60/40"] = 0.6 * exReturns["exequity"] + 0.4 * exReturns["exbond"]
exReturns["60/40_5Futu"] = 0.95 * exReturns["60/40"] + 0.05 * exReturns["exfutucom"]
exReturns["60/40_10Futu"] = 0.90 * exReturns["60/40"] + 0.10 * exReturns["exfutucom"]
exReturns["60/40_20Futu"] = 0.80 * exReturns["60/40"] + 0.20 * exReturns["exfutucom"]
exReturns["60/40_30Futu"] = 0.70 * exReturns["60/40"] + 0.30 * exReturns["exfutucom"]
exReturns["60/40_18Futu"] = 0.82 * exReturns["60/40"] + 0.18 * exReturns["exfutucom"]
exReturns["60/40_49Futu"] = 0.51 * exReturns["60/40"] + 0.49 * exReturns["exfutucom"]
exReturns["28v46v26"] = 0.4588 * exReturns["exbond"] + 0.26 * exReturns["exfutucom"] + 0.2812 * exReturns["exequity"]
exReturns["84v0v16"] = 0.16 * exReturns["exfutucom"] + 0.84 * exReturns["exequity"]
exReturns["aggbackcon"] = data["Aggregatebackcon"]
#exReturns["int_yearly_change"] = data["int_yearly_change"]


#################
#Her kommer sorting på monthly data

data_to_sort = exReturns.copy()
data_to_sort = data_to_sort.join(data["Stateofbackcon"]).join(data["statinf"]) 
sort_backcon = data_to_sort.sort_values("Stateofbackcon") #back til indeks 811, contango from 812
back = sort_backcon.iloc[0:812,:]
contango = sort_backcon.iloc[812:,:]

backStats = back.describe()
backStats.loc["mean"] = (backStats.loc["mean"]+1)**12-1
backStats.loc["std"] = backStats.loc["std"]*np.sqrt(12)
backStats.loc["SR"] = backStats.iloc[1]/backStats.iloc[2]

backStats.loc["skew"] = back.skew()
backStats.loc["excessKurtosis"] = back.kurtosis()


contangoStats = contango.describe()
contangoStats.loc["mean"] = (contangoStats.loc["mean"]+1)**12-1
contangoStats.loc["std"] = contangoStats.loc["std"]*np.sqrt(12)
contangoStats.loc["SR"] = contangoStats.iloc[1]/contangoStats.iloc[2]

contangoStats.loc["skew"] = contango.skew()
contangoStats.loc["excessKurtosis"] = contango.kurtosis()
###
Indexes = exReturns.copy()
Indexes.iloc[:,1:] = np.cumprod(Indexes.iloc[:, 1:]+1)

#årlig 
data_to_sort_aarlig = Indexes.iloc[12:,1:]/Indexes.iloc[:len(Indexes)-12,1:]

data_to_sort_aarlig = Indexes.iloc[12:,:].copy()
for i in range(len(data_to_sort_aarlig)):
    data_to_sort_aarlig.iloc[i,1:] = Indexes.iloc[i+12,1:]/Indexes.iloc[i,1:]-1
    

data_to_sort_aarlig["InfYearly"] = data.infYearly[12:]
data_to_sort_aarlig["int_yearly_change"] = data.int_yearly_change[12:]

#Looking at descriptive of quintiles of inflation månedlig 
data_to_sort = data_to_sort.join(data["infMonth"])
sort_infMonth = data_to_sort.sort_values("infMonth")
intervall = int(1750/5)
sort_infMonth_stat_1 = sort_infMonth[0:intervall].describe()

sort_infMonth_stat_2 = sort_infMonth[intervall:intervall*2].describe()

sort_infMonth_stat_3 = sort_infMonth[intervall*2:intervall*3].describe()

sort_infMonth_stat_4 = sort_infMonth[intervall*3:intervall*4].describe()

sort_infMonth_stat_5 = sort_infMonth[intervall*4:].describe()


table_infMonth_quintile = pd.DataFrame(columns=['0%-20%', "20%-40%", "40%-60%",'60%-80%','80%-100%'])
table_infMonth_quintile = pd.DataFrame(columns=['1', "2", "3",'4','5'])


table_infMonth_quintile.loc["infMonth mean"] = [sort_infMonth_stat_1["infMonth"][1],sort_infMonth_stat_2["infMonth"][1],sort_infMonth_stat_3["infMonth"][1],sort_infMonth_stat_4["infMonth"][1],sort_infMonth_stat_5["infMonth"][1]]


sort_infMonth_stat_1 = sort_infMonth[0:intervall].describe()

sort_infMonth_stat_2 = sort_infMonth[intervall:intervall*2].describe()

sort_infMonth_stat_3 = sort_infMonth[intervall*2:intervall*3].describe()

sort_infMonth_stat_4 = sort_infMonth[intervall*3:intervall*4].describe()

sort_infMonth_stat_5 = sort_infMonth[intervall*4:].describe()



table_infMonth_quintile.loc["60/40 mean"] = [sort_infMonth_stat_1["60/40"][1],sort_infMonth_stat_2["60/40"][1],sort_infMonth_stat_3["60/40"][1],sort_infMonth_stat_4["60/40"][1],sort_infMonth_stat_5["60/40"][1]]

table_infMonth_quintile.loc["exequity mean"] = [sort_infMonth_stat_1["exequity"][1],sort_infMonth_stat_2["exequity"][1],sort_infMonth_stat_3["exequity"][1],sort_infMonth_stat_4["exequity"][1],sort_infMonth_stat_5["exequity"][1]]

table_infMonth_quintile.loc["exbond mean"] = [sort_infMonth_stat_1["exbond"][1],sort_infMonth_stat_2["exbond"][1],sort_infMonth_stat_3["exbond"][1],sort_infMonth_stat_4["exbond"][1],sort_infMonth_stat_5["exbond"][1]]


table_infMonth_quintile.loc["exfutucom mean"] = [sort_infMonth_stat_1["exfutucom"][1],sort_infMonth_stat_2["exfutucom"][1],sort_infMonth_stat_3["exfutucom"][1],sort_infMonth_stat_4["exfutucom"][1],sort_infMonth_stat_5["exfutucom"][1]]


## plot månedlig

inflation_quintile_plot_månedlig = table_infMonth_quintile.transpose()

# Create a figure and axis object
fig, ax = plt.subplots()

# Set the width of each bar
bar_width = 0.15

# Create a numpy array of the x-axis values
x = np.arange(len(inflation_quintile_plot_månedlig.index))

# Define the colors for each asset
colors = ['#00897B', '#F44336', '#FFC107', '#37474F', '#3F51B5']

# Plot the bars for each asset with the appropriate color
ax.bar(x - 2*bar_width, inflation_quintile_plot_månedlig['exfutucom mean'], width=bar_width, label='Commodity futures', edgecolor='black', linewidth=0.5, color=colors[0])
ax.bar(x - bar_width, inflation_quintile_plot_månedlig['60/40 mean'], width=bar_width, label='60/40 portfolio', edgecolor='black', linewidth=0.5, color=colors[1])
ax.bar(x, inflation_quintile_plot_månedlig['exequity mean'], width=bar_width, label='Stock', edgecolor='black', linewidth=0.5, color=colors[2])
ax.bar(x + bar_width, inflation_quintile_plot_månedlig['exbond mean'], width=bar_width, label='Bond', edgecolor='black', linewidth=0.5, color=colors[3])
ax.bar(x + 2*bar_width, inflation_quintile_plot_månedlig['infMonth mean'], width=bar_width, label='Monthly Inflation mean level', edgecolor='black', linewidth=0.5, color=colors[4])

# Add labels and title
ax.set_xlabel('Quantiles', fontsize=12, fontweight='bold')
ax.set_ylabel('Mean Return', fontsize=12, fontweight='bold')
ax.set_title('Monlthy Mean Return in Quantiles based on Monlthy Inflation level', fontsize=14, fontweight='bold')

# Set the x-axis ticks and tick labels
ax.set_xticks(x)
ax.set_xticklabels(inflation_quintile_plot_månedlig.index, fontsize=10)

# Set the y-axis ticks and tick labels
ax.tick_params(axis='y', labelsize=10)

# Add a legend
ax.legend(fontsize=10)

# Set the background color to light grey and add a grid
ax.set_facecolor('#F1F1F1')
#ax.grid(color='white', linestyle='--', linewidth=0.5)

# Set the figure size and save the plot to a file
fig.set_size_inches(8, 6)
fig.savefig('inf_quantiles_mean_MONTHLYreturn.png', dpi=300, bbox_inches='tight')

# Show the plot
plt.show()


import matplotlib.pyplot as plt
import numpy as np

# Create a figure and axis object
fig, ax = plt.subplots()

# Set the width of each bar
bar_width = 0.15

# Create a numpy array of the x-axis values
x = np.arange(len(inflation_quintile_plot_månedlig.index))

# Define the colors for each asset
colors = ['#00897B', '#F44336', '#FFC107', '#37474F', '#3F51B5']
colors = ['#00897B', '#F44336','#3f85f5', '#37474F', '#FFC107' ]
colors = ['#00897B', '#F44336','#3f85f5', '#37474F','#FFC107' ]

# Plot the bars for each asset with the appropriate color
ax.bar(x - 2*bar_width, inflation_quintile_plot_månedlig['exfutucom mean'], width=bar_width, label='Commodity futures', edgecolor='black', linewidth=0.5, color=colors[0])
ax.bar(x - bar_width, inflation_quintile_plot_månedlig['60/40 mean'], width=bar_width, label='60/40', edgecolor='black', linewidth=0.5, color=colors[3])
ax.bar(x, inflation_quintile_plot_månedlig['exequity mean'], width=bar_width, label='Stocks', edgecolor='black', linewidth=0.5, color=colors[1])
ax.bar(x + bar_width, inflation_quintile_plot_månedlig['exbond mean'], width=bar_width, label='Bonds', edgecolor='black', linewidth=0.5, color=colors[2])
ax.bar(x + 2*bar_width, inflation_quintile_plot_månedlig['infMonth mean'], width=bar_width, label='Inflation', edgecolor='black', linewidth=0.5, color=colors[4])

# Add labels and title with Times New Roman font
ax.set_xlabel('Quantiles', fontsize=18, fontfamily='Times New Roman')
ax.set_ylabel('Mean Return', fontsize=18, fontfamily='Times New Roman')
ax.set_title(' Conditional on Inflation', fontsize=26, fontfamily='Times New Roman')

# Set the x-axis ticks and tick labels with Times New Roman font
ax.set_xticks(x, fontsize = 16)
ax.set_xticklabels(inflation_quintile_plot_månedlig.index, fontsize=16, fontfamily='Times New Roman')

# Set the tick labels font
#ax.set_xticklabels(ax.get_xticklabels(), fontdict={'family': 'Times New Roman', 'size': 16})
#ax.set_yticklabels(ax.get_yticklabels(), fontdict={'family': 'Times New Roman', 'size': 16})
#
# Add a legend with Times New Roman font
ax.legend(fontsize=16, prop={'family': 'Times New Roman', 'size':12})

# Set the background color to light grey and add a grid
ax.set_facecolor('#F1F1F1')
#ax.grid(color='white', linestyle='--', linewidth=0.5)

# Set the figure size and save the plot to a file
fig.set_size_inches(8, 6)
fig.savefig('inf_quantiles_mean_MONTHLYreturn.png', dpi=300, bbox_inches='tight')

# Set the y-axis ticks and tick labels with Times New Roman font and larger font size
ax.set_yticks(ax.get_yticks())
ax.set_yticklabels(ax.get_yticklabels(), fontsize=16, fontfamily='Times New Roman')

# Set the x-axis and y-axis label font to Times New Roman
ax.set_xlabel('Quantiles', fontsize=20, fontfamily='Times New Roman')
ax.set_ylabel('Mean Return', fontsize=20, fontfamily='Times New Roman')

# Set the x-axis tick labels font to Times New Roman
ax.set_xticklabels(inflation_quintile_plot_månedlig.index, fontsize=16, fontfamily='Times New Roman')

# Set the legend font to Times New Roman
ax.legend(fontsize=16, prop={'family': 'Times New Roman', 'size': 12})

# Show the plot
plt.show()



##################################################
###########################
#Looking at descriptive of quintiles of aggeregate backwardation/contango!!!! har ikke endret alle variabel navn, må kjøre en og en plot (heter inf her også)
data_to_sort = data_to_sort.join(data["Aggregatebackcon"])
sort_infMonth = data_to_sort.sort_values("Aggregatebackcon")
intervall = int(1750/5)
sort_infMonth_stat_1 = sort_infMonth[0:intervall].describe()

sort_infMonth_stat_2 = sort_infMonth[intervall:intervall*2].describe()

sort_infMonth_stat_3 = sort_infMonth[intervall*2:intervall*3].describe()

sort_infMonth_stat_4 = sort_infMonth[intervall*3:intervall*4].describe()

sort_infMonth_stat_5 = sort_infMonth[intervall*4:].describe()


table_infMonth_quintile = pd.DataFrame(columns=['0%-20%', "20%-40%", "40%-60%",'60%-80%','80%-100%'])
table_infMonth_quintile = pd.DataFrame(columns=['1', "2", "3",'4','5'])

table_infMonth_quintile.loc["Agggregatebackcon mean"] = [sort_infMonth_stat_1["Aggregatebackcon"][1],sort_infMonth_stat_2["Aggregatebackcon"][1],sort_infMonth_stat_3["Aggregatebackcon"][1],sort_infMonth_stat_4["Aggregatebackcon"][1],sort_infMonth_stat_5["Aggregatebackcon"][1]]


sort_infMonth_stat_1 = sort_infMonth[0:intervall].describe()

sort_infMonth_stat_2 = sort_infMonth[intervall:intervall*2].describe()

sort_infMonth_stat_3 = sort_infMonth[intervall*2:intervall*3].describe()

sort_infMonth_stat_4 = sort_infMonth[intervall*3:intervall*4].describe()

sort_infMonth_stat_5 = sort_infMonth[intervall*4:].describe()



table_infMonth_quintile.loc["60/40 mean"] = [sort_infMonth_stat_1["60/40"][1],sort_infMonth_stat_2["60/40"][1],sort_infMonth_stat_3["60/40"][1],sort_infMonth_stat_4["60/40"][1],sort_infMonth_stat_5["60/40"][1]]

table_infMonth_quintile.loc["exequity mean"] = [sort_infMonth_stat_1["exequity"][1],sort_infMonth_stat_2["exequity"][1],sort_infMonth_stat_3["exequity"][1],sort_infMonth_stat_4["exequity"][1],sort_infMonth_stat_5["exequity"][1]]

table_infMonth_quintile.loc["exbond mean"] = [sort_infMonth_stat_1["exbond"][1],sort_infMonth_stat_2["exbond"][1],sort_infMonth_stat_3["exbond"][1],sort_infMonth_stat_4["exbond"][1],sort_infMonth_stat_5["exbond"][1]]


table_infMonth_quintile.loc["exfutucom mean"] = [sort_infMonth_stat_1["exfutucom"][1],sort_infMonth_stat_2["exfutucom"][1],sort_infMonth_stat_3["exfutucom"][1],sort_infMonth_stat_4["exfutucom"][1],sort_infMonth_stat_5["exfutucom"][1]]


## plot månedlig

inflation_quintile_plot_månedlig = table_infMonth_quintile.transpose()

# Create a figure and axis object
fig, ax = plt.subplots()

# Set the width of each bar
bar_width = 0.15

# Create a numpy array of the x-axis values
x = np.arange(len(inflation_quintile_plot_månedlig.index))

# Define the colors for each asset
colors = ['#00897B', '#F44336', '#FFC107', '#37474F', '#3F51B5']
colors = ['#00897B', '#F44336','#3f85f5', '#37474F','#FFC107' ]

# Plot the bars for each asset with the appropriate color
ax.bar(x - 2*bar_width, inflation_quintile_plot_månedlig['exfutucom mean'], width=bar_width, label='Commodity futures', edgecolor='black', linewidth=0.5, color=colors[0])
ax.bar(x - bar_width, inflation_quintile_plot_månedlig['60/40 mean'], width=bar_width, label='60/40', edgecolor='black', linewidth=0.5, color=colors[3])
ax.bar(x, inflation_quintile_plot_månedlig['exequity mean'], width=bar_width, label='Stocks', edgecolor='black', linewidth=0.5, color=colors[1])
ax.bar(x + bar_width, inflation_quintile_plot_månedlig['exbond mean'], width=bar_width, label='Bonds', edgecolor='black', linewidth=0.5, color=colors[2])
ax.bar(x + 2*bar_width, inflation_quintile_plot_månedlig['Agggregatebackcon mean'], width=bar_width, label='Aggregate Back/Con', edgecolor='black', linewidth=0.5, color=colors[4])

# Add labels and title with Times New Roman font
ax.set_xlabel('Quantiles', fontsize=18, fontfamily='Times New Roman')
ax.set_ylabel('Mean Return', fontsize=18, fontfamily='Times New Roman')
ax.set_title(' Conditional on Backwardation', fontsize=26, fontfamily='Times New Roman')

# Set the x-axis ticks and tick labels with Times New Roman font
ax.set_xticks(x, fontsize = 20)
ax.set_xticklabels(inflation_quintile_plot_månedlig.index, fontsize=16, fontfamily='Times New Roman')

#ax.set_yticks(inflation_quintile_plot_månedlig, fontsize = 16, fontfamily = "Times new Roman")
#ax.set_yticklabels(ax.get_yticklabels(), fontsize=16, fontfamily='Times New Roman')


# Set the tick labels font
#ax.set_xticklabels(ax.get_xticklabels(), fontdict={'family': 'Times New Roman', 'size': 16})
#ax.set_yticklabels(ax.get_yticklabels(), fontdict={'family': 'Times New Roman', 'size': 12})

# Add a legend with Times New Roman font
ax.legend(fontsize=16, prop={'family': 'Times New Roman', 'size':12})

# Set the background color to light grey and add a grid
ax.set_facecolor('#F1F1F1')
#ax.grid(color='white', linestyle='--', linewidth=0.5)

# Set the figure size and save the plot to a file
fig.set_size_inches(8, 6)
fig.savefig('Agggregatebackcon_quantiles_mean_MONTHLYreturn.png', dpi=300, bbox_inches='tight')

# Set the y-axis ticks and tick labels with Times New Roman font and larger font size
ax.set_yticks(ax.get_yticks())
ax.set_yticklabels(ax.get_yticklabels(), fontsize=16, fontfamily='Times New Roman')

# Set the x-axis and y-axis label font to Times New Roman
ax.set_xlabel('Quantiles', fontsize=20, fontfamily='Times New Roman')
ax.set_ylabel('Mean Return', fontsize=20, fontfamily='Times New Roman')

# Set the x-axis tick labels font to Times New Roman
ax.set_xticklabels(inflation_quintile_plot_månedlig.index, fontsize=16, fontfamily='Times New Roman')

# Set the legend font to Times New Roman
ax.legend(fontsize=16, prop={'family': 'Times New Roman', 'size': 12})




# Show the plot
plt.show()

######################
######################################




