
import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
import scipy
import math
import statistics
import os
import seaborn as sns
import pandas as pd


#Data
data = pd.read_excel("main_data.xlsx")
data['date'] = pd.to_datetime(data['date'])
data["int_yearly_change"] = -data.infYearly.shift(1)+data.infYearly



#stats for excess returns of spot, futu, bond, equtiy, rf and 60/40
exReturns = data.iloc[:,[0,1,2,3,4]]
exReturns["60/40"] = 0.6 * exReturns["exequity"] + 0.4 * exReturns["exbond"]
exReturns["60/40_5Futu"] = 0.95 * exReturns["60/40"] + 0.05 * exReturns["exfutucom"]
exReturns["60/40_10Futu"] = 0.90 * exReturns["60/40"] + 0.10 * exReturns["exfutucom"]
exReturns["60/40_20Futu"] = 0.80 * exReturns["60/40"] + 0.20 * exReturns["exfutucom"]
exReturns["60/40_30Futu"] = 0.70 * exReturns["60/40"] + 0.30 * exReturns["exfutucom"]
exReturns["60/40_18Futu"] = 0.82 * exReturns["60/40"] + 0.18 * exReturns["exfutucom"]
exReturns["60/40_49Futu"] = 0.51 * exReturns["60/40"] + 0.49 * exReturns["exfutucom"]
exReturns["28v46v26"] = 0.4588 * exReturns["exbond"] + 0.26 * exReturns["exfutucom"] + 0.2812 * exReturns["exequity"]
exReturns["84v0v16"] = 0.16 * exReturns["exfutucom"] + 0.84 * exReturns["exequity"]
exReturns["aggbackcon"] = data["Aggregatebackcon"]
#exReturns["int_yearly_change"] = data["int_yearly_change"]


#################
#Her kommer sorting på monthly data

data_to_sort = exReturns.copy()
data_to_sort = data_to_sort.join(data["Stateofbackcon"]).join(data["statinf"]) 
sort_backcon = data_to_sort.sort_values("Stateofbackcon") #back til indeks 811, contango from 812
back = sort_backcon.iloc[0:812,:]
contango = sort_backcon.iloc[812:,:]

backStats = back.describe()
backStats.loc["mean"] = (backStats.loc["mean"]+1)**12-1
backStats.loc["std"] = backStats.loc["std"]*np.sqrt(12)
backStats.loc["SR"] = backStats.iloc[1]/backStats.iloc[2]

backStats.loc["skew"] = back.skew()
backStats.loc["excessKurtosis"] = back.kurtosis()


contangoStats = contango.describe()
contangoStats.loc["mean"] = (contangoStats.loc["mean"]+1)**12-1
contangoStats.loc["std"] = contangoStats.loc["std"]*np.sqrt(12)
contangoStats.loc["SR"] = contangoStats.iloc[1]/contangoStats.iloc[2]

contangoStats.loc["skew"] = contango.skew()
contangoStats.loc["excessKurtosis"] = contango.kurtosis()
###
Indexes = exReturns.copy()
Indexes.iloc[:,1:] = np.cumprod(Indexes.iloc[:, 1:]+1)

#årlig 
data_to_sort_aarlig = Indexes.iloc[12:,1:]/Indexes.iloc[:len(Indexes)-12,1:]

data_to_sort_aarlig = Indexes.iloc[12:,:].copy()
for i in range(len(data_to_sort_aarlig)):
    data_to_sort_aarlig.iloc[i,1:] = Indexes.iloc[i+12,1:]/Indexes.iloc[i,1:]-1
    

data_to_sort_aarlig["InfYearly"] = data.infYearly[12:]
data_to_sort_aarlig["int_yearly_change"] = data.int_yearly_change[12:]

##################################################################
#Looking at descriptive of quintiles of 60/40 
# Maybe it should not be converted to yearly and only use monthly. As it becomes a bot massive with yearly, sharp does not give any meaning, as they are sorted
sort_60_40 = data_to_sort.sort_values("60/40")
intervall = int(1750/10)
sort_60_40_stat_1 = sort_60_40[0:intervall].describe()

sort_60_40_stat_2 = sort_60_40[intervall:intervall*2].describe()

sort_60_40_stat_3 = sort_60_40[intervall*2:intervall*3].describe()

sort_60_40_stat_4 = sort_60_40[intervall*3:intervall*4].describe()

sort_60_40_stat_5 = sort_60_40[intervall*4:intervall*5].describe()


sort_60_40_stat_6 = sort_60_40[intervall*5:intervall*6].describe()

sort_60_40_stat_7 = sort_60_40[intervall*6:intervall*7].describe()

sort_60_40_stat_8 = sort_60_40[intervall*7:intervall*8].describe()

sort_60_40_stat_9 = sort_60_40[intervall*8:intervall*9].describe()

sort_60_40_stat_10 = sort_60_40[intervall*9:].describe()


table_60_40_quintile = pd.DataFrame(sort_60_40_stat_1.iloc[1,[4,0,2,3]])#.join(sort_60_40_stat_2.iloc[1,[4,0,2,3]]).join(sort_60_40_stat_3.iloc[1,[4,0,2,3]]).join(sort_60_40_stat_4.iloc[1,[4,0,2,3]]).join(sort_60_40_stat_5.iloc[1,[4,0,2,3]])
table_60_40_quintile.columns = ['1']
table_60_40_quintile = table_60_40_quintile.join(sort_60_40_stat_2.iloc[1,[4,0,2,3]])
table_60_40_quintile.rename(columns = {'mean':'2'}, inplace = True) 
table_60_40_quintile = table_60_40_quintile.join(sort_60_40_stat_3.iloc[1,[4,0,2,3]])
table_60_40_quintile.rename(columns = {'mean':'3'}, inplace = True) 
table_60_40_quintile = table_60_40_quintile.join(sort_60_40_stat_4.iloc[1,[4,0,2,3]])
table_60_40_quintile.rename(columns = {'mean':'4'}, inplace = True) 
table_60_40_quintile = table_60_40_quintile.join(sort_60_40_stat_5.iloc[1,[4,0,2,3]])
table_60_40_quintile.rename(columns = {'mean':'5'}, inplace = True) 
table_60_40_quintile = table_60_40_quintile.join(sort_60_40_stat_6.iloc[1,[4,0,2,3]])#.join(sort_60_40_stat_2.iloc[1,[4,0,2,3]]).join(sort_60_40_stat_3.iloc[1,[4,0,2,3]]).join(sort_60_40_stat_4.iloc[1,[4,0,2,3]]).join(sort_60_40_stat_5.iloc[1,[4,0,2,3]])
table_60_40_quintile.rename(columns = {'mean':'6'}, inplace = True) 

table_60_40_quintile = table_60_40_quintile.join(sort_60_40_stat_7.iloc[1,[4,0,2,3]])
table_60_40_quintile.rename(columns = {'mean':'7'}, inplace = True) 
table_60_40_quintile = table_60_40_quintile.join(sort_60_40_stat_8.iloc[1,[4,0,2,3]])
table_60_40_quintile.rename(columns = {'mean':'8'}, inplace = True) 
table_60_40_quintile = table_60_40_quintile.join(sort_60_40_stat_9.iloc[1,[4,0,2,3]])
table_60_40_quintile.rename(columns = {'mean':'9'}, inplace = True) 
table_60_40_quintile = table_60_40_quintile.join(sort_60_40_stat_10.iloc[1,[4,0,2,3]])
table_60_40_quintile.rename(columns = {'mean':'10'}, inplace = True)


## plot 60/40 quantiles

sixtyforthy_quintile_plot = table_60_40_quintile.transpose()

"""
# Create a figure and axis object
fig, ax = plt.subplots()

# Set the width of each bar
bar_width = 0.15

# Create a numpy array of the x-axis values
x = np.arange(len(sixtyforthy_quintile_plot.index))

# Define the colors for each asset
colors = ['#00897B', '#F44336', '#FFC107', '#37474F', '#3F51B5']

# Plot the bars for each asset with the appropriate color
ax.bar(x - 2*bar_width, sixtyforthy_quintile_plot['exfutucom'], width=bar_width, label='Commodity futures', edgecolor='black', linewidth=0.5, color=colors[0])
ax.bar(x - bar_width, sixtyforthy_quintile_plot['60/40'], width=bar_width, label='60/40 portfolio', edgecolor='black', linewidth=0.5, color=colors[1])
ax.bar(x, sixtyforthy_quintile_plot['exequity'], width=bar_width, label='Stock', edgecolor='black', linewidth=0.5, color=colors[2])
ax.bar(x + bar_width, sixtyforthy_quintile_plot['exbond'], width=bar_width, label='Bond', edgecolor='black', linewidth=0.5, color=colors[3])
#ax.bar(x + 2*bar_width, sixtyforthy_quintile_plot['inflation mean'], width=bar_width, label='Yearly Inflation mean level', edgecolor='black', linewidth=0.5, color=colors[4])

# Add labels and title
ax.set_xlabel('Quantiles', fontsize=12, fontweight='bold')
ax.set_ylabel('Mean Return', fontsize=12, fontweight='bold')
ax.set_title('Monthly Mean Return in Quantiles of 60/40 returns', fontsize=14, fontweight='bold')

# Set the x-axis ticks and tick labels
ax.set_xticks(x)
ax.set_xticklabels(sixtyforthy_quintile_plot.index, fontsize=10)

# Set the y-axis ticks and tick labels
ax.tick_params(axis='y', labelsize=10)

# Add a legend
ax.legend(fontsize=10)

# Set the background color to light grey and add a grid
ax.set_facecolor('#F1F1F1')
#ax.grid(color='white', linestyle='--', linewidth=0.5)

# Set the figure size and save the plot to a file
fig.set_size_inches(8, 6)
fig.savefig('6040_quantiles_mean_return.png', dpi=300, bbox_inches='tight')

# Show the plot
plt.show()
"""
"""
#lage latex tabell
table_60_40_quintile = table_60_40_quintile.mul(100).round(1).astype(str).add("%")
table_60_40_quintile.rename({"exfutucom":"Commodity futures", "exequity":"Stock", "exbond":"Bond"}, inplace = True)
table_60_40_quintile = table_60_40_quintile.reset_index()
print(table_60_40_quintile.to_latex(index = False, multirow = True))
"""
import matplotlib.pyplot as plt
import numpy as np

# Create a figure and axis object
fig, ax = plt.subplots(figsize=(12, 6))
plt.rcParams['font.family'] = 'Times New Roman'

# Set the width of each bar
bar_width = 0.15

# Create a numpy array of the x-axis values
x = np.arange(len(sixtyforthy_quintile_plot.index))

# Define the colors for each asset
colors = ['#00897B', '#F44336','#3f85f5', '#37474F']

# Plot the bars for each asset with the appropriate color
ax.bar(x - 2*bar_width, sixtyforthy_quintile_plot['exfutucom'], width=bar_width, label='Commodity futures', edgecolor='black', linewidth=0.5, color=colors[0])
ax.bar(x - bar_width, sixtyforthy_quintile_plot['60/40'], width=bar_width, label='60/40', edgecolor='black', linewidth=0.5, color=colors[3])
ax.bar(x, sixtyforthy_quintile_plot['exequity'], width=bar_width, label='Stocks', edgecolor='black', linewidth=0.5, color=colors[1])
ax.bar(x + bar_width, sixtyforthy_quintile_plot['exbond'], width=bar_width, label='Bonds', edgecolor='black', linewidth=0.5, color=colors[2])

# Add labels and title with Times New Roman font
ax.set_xlabel('Quantiles', fontsize=18, fontfamily='Times New Roman')
ax.set_ylabel('Mean Return', fontsize=18, fontfamily='Times New Roman')
ax.set_title('Mean Returns Conditional on 60/40 Returns', fontsize=26, fontfamily='Times New Roman')

# Set the x-axis ticks and tick labels with Times New Roman font
ax.set_xticks(x)
ax.set_xticklabels(sixtyforthy_quintile_plot.index, fontsize=16, fontfamily='Times New Roman')


# Set the tick labels font
ax.set_xticklabels(ax.get_xticklabels(), fontdict={'family': 'Times New Roman', 'size': 16})
#ax.set_yticklabels(ax.get_yticklabels(), fontdict={'family': 'Times New Roman', 'size': 12})


# Add a legend with Times New Roman font
legend_font = {'family': 'Times New Roman', 'size': 16}
ax.legend(fontsize=16, prop=legend_font)

# Set the background color to light grey and add a grid
ax.set_facecolor('#F1F1F1')
#ax.grid(color='white', linestyle='--', linewidth=0.5)

# Set the figure size and save the plot to a file
#fig.set_size_inches(8, 6)
#fig.save fig('6040_quantiles_mean_return.png', dpi=300, bbox_inches='tight')
import matplotlib.ticker as ticker

# ...

# Set the y-axis ticks and tick labels with Times New Roman font and larger font size
ax.set_yticks(ax.get_yticks())
ax.set_yticklabels(ax.get_yticks(), fontsize=16, fontfamily='Times New Roman')

# Limit the number of decimal places in y-axis tick labels to two
ax.yaxis.set_major_formatter(ticker.FormatStrFormatter('%.2f'))

# ...


# Show the plot
plt.show()

