

import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
import scipy
import math
import statistics
import os
import seaborn as sns
import pandas as pd


os.getcwd()

#Data
data = pd.read_excel("main_data.xlsx")
data['date'] = pd.to_datetime(data['date'])

# Portfolios
data["60/40"] = data["exequity"]*0.6 + data["exbond"]*0.4

#data["60/40/20"] = data["60/40"]*0.80 + data["exfutucom"]*0.20



# Rolling correlations
i = 60 #months of rolling correlation
col_names = ["date", "com fut vs spot", "com vs eq", "com vs bond", "eq vs bond"]
rolling_corr = pd.DataFrame()
rolling_corr["date"] = data["date"]
rolling_corr["Stock vs Bond"] = data["exequity"].rolling(window = i).corr(other=data["exbond"])
#rolling_corr[ "com vs spot"]     = data["exfutucom"].rolling(window = i).corr(other=data["exspotcom"])
#rolling_corr["Commodity futures vs Stock"] = data["exfutucom"].rolling(window =i).corr(other=data["exequity"])
#rolling_corr["Commodity futures vs Bond"] = data["exfutucom"].rolling(window = i).corr(other=data["exbond"])
rolling_corr["60/40 vs Commodity futures"] = data["exfutucom"].rolling(window =i).corr(other=data["60/40"])
rolling_corr = rolling_corr.set_index(["date"])
rolling_corr = rolling_corr.dropna(how = "all")


"""# Define figure size and dpi
fig, ax = plt.subplots(figsize=(12, 6), dpi=100)

# Plot the rolling correlations with a line width of 2
rolling_corr.plot(ax=ax, lw=2)

# Set title and axis labels
ax.set_title("5 Year Rolling Correlations", fontsize=14, fontfamily='Times New Roman')
ax.set_xlabel("Year", fontsize=12, fontfamily='Times New Roman')
ax.set_ylabel("Correlation Coefficient", fontsize=12, fontfamily='Times New Roman')

# Customize the legend
ax.legend(loc="upper left", fontsize=12, fontfamily='Times New Roman')

# Customize the grid
ax.grid(True, linestyle='--', linewidth=0.5, alpha=0.5)

# Set x-axis tick label size
ax.tick_params(axis='x', which='major', labelsize=10)

# Add horizontal line at correlation coefficient = 0
ax.axhline(y=0, color='black', linestyle='--', linewidth=0.5, alpha=0.5)

# Show the plot
plt.show()

"""

# Define figure size and dpi
fig, ax = plt.subplots(figsize=(12, 6), dpi=100)

# Plot the rolling correlations with a line width of 2 and custom colors
rolling_corr.plot(ax=ax, lw=2, color=[ '#FFB74D', '#000066', '#2874A6'])

# Set title and axis labels
ax.set_title("Rolling 5-Year Correlations", fontsize=26, fontfamily='Times New Roman')
ax.set_xlabel("Year", fontsize=16, fontfamily='Times New Roman')
ax.set_ylabel("Correlation", fontsize=16, fontfamily='Times New Roman')

# Customize the legend
ax.legend(fontsize=16, prop={'family': 'Times New Roman', 'size':16})

# Customize the grid
ax.grid(True, linestyle='--', linewidth=0.5, alpha=0.5)

# Set x-axis tick label size
ax.tick_params(axis='x', which='major', labelsize=16)
# Set the tick labels font
ax.set_xticklabels(ax.get_xticklabels(), fontdict={'family': 'Times New Roman', 'size': 16})
ax.set_yticklabels(ax.get_yticklabels(), fontdict={'family': 'Times New Roman', 'size': 16})

# Customize the grid
ax.grid(True, linestyle='--', linewidth=0.5, alpha=0.5)

# Add horizontal line at correlation coefficient = 0
ax.axhline(y=0, color='black', linestyle='--', linewidth=0.5, alpha=0.5)

# Set font to Times New Roman for all text elements
ax.set_title(ax.get_title(), fontfamily='Times New Roman', fontsize=26)
ax.set_xlabel(ax.get_xlabel(), fontfamily='Times New Roman', fontsize=16)
ax.set_ylabel(ax.get_ylabel(), fontfamily='Times New Roman', fontsize=16)
ax.legend( prop={'family': 'Times New Roman', 'size': 14})
ax.tick_params(axis='both', labelsize=16)

# Show the plot
plt.show()
