
import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
import scipy
import math
import statistics
import os
from tabulate import tabulate
#from prettytable import PrettyTable


os.getcwd()

#Data
data = pd.read_excel("main_data.xlsx")
data['date'] = pd.to_datetime(data['date'])
data["60/40"] = 0.6 * data["exequity"] + 0.4 * data["exbond"]
#Data manipulering
#data.iloc[871,4]=0.0039

#stats for excess returns of spot, futu, bond, equtiy, rf and 60/40
exReturns = data.iloc[:,[0,1,2,3,4,5, 20]]
exReturns = exReturns.join(data["Rf"])

ln_exReturns = np.log(1 + exReturns.iloc[:,1:])

exStats = exReturns.describe()
lnexStats = ln_exReturns.describe()

#exStats.loc["mean"] = (exStats.loc["mean"]+1)**12-1
exStats.loc["mean"] = (exStats.loc["mean"])*12
#exStats.loc["geometric mean"] = np.exp((lnexStats.loc["mean"]))**12-1   
exStats.loc["geometric mean"] = (lnexStats.loc["mean"])*12   



exStats.loc["std"] = exStats.loc["std"]*np.sqrt(12)
exStats.loc["SR"] = exStats.iloc[1]/exStats.iloc[2]

exStats.loc["skew"] = exReturns.skew()
exStats.loc["excessKurtosis"] = exReturns.kurtosis()

#stats for excess returns of spot, futu, bond, equtiy, interest adjusted carry rf and 60/40: Befor 1945
exReturns1877_1945 = data.iloc[0:826,[0,1,2,3,4,5,20]]


exReturns1877_1945 = exReturns1877_1945.join(data["Rf"])
ln_exReturns1877_1945 = np.log(1 + exReturns1877_1945.iloc[:,1:])

exStats1877_1945 = exReturns1877_1945.describe()
lnexStats1877_1945 = ln_exReturns1877_1945.describe()

#exStats1877_1945.loc["mean"] = (exStats1877_1945.loc["mean"]+1)**12-1
exStats1877_1945.loc["mean"] = (exStats1877_1945.loc["mean"])*12
#exStats1877_1945.loc["geometric mean"] = (np.exp(lnexStats1877_1945.loc["mean"]))**12-1
exStats1877_1945.loc["geometric mean"] = (lnexStats1877_1945.loc["mean"])*12



exStats1877_1945.loc["std"] = exStats1877_1945.loc["std"]*np.sqrt(12)
exStats1877_1945.loc["SR"] = exStats1877_1945.iloc[1]/exStats1877_1945.iloc[2]


exStats1877_1945.loc["skew"] = exReturns1877_1945.skew()
exStats1877_1945.loc["excessKurtosis"] = exReturns1877_1945.kurtosis()

#stats for excess returns of spot, futu, bond, equtiy, rf and 60/40: from 1946 present
exReturns1946_2022 = data.iloc[827:,[0,1,2,3,4,5, 20]]


exReturns1946_2022 = exReturns1946_2022.join(data["Rf"])
lnexReturns1946_2022 = np.log(1+ exReturns1946_2022.iloc[:,1:])

exStats1946_2022 = exReturns1946_2022.describe()
lnexStats1946_2022 = lnexReturns1946_2022.describe()
#exStats1946_2022.loc["mean"] = (exStats1946_2022.loc["mean"]+1)**12-1
exStats1946_2022.loc["mean"] = (exStats1946_2022.loc["mean"])*12
#exStats1946_2022.loc["geometric mean"] = (np.exp(lnexStats1946_2022.loc["mean"]))**12-1
exStats1946_2022.loc["geometric mean"] = (lnexStats1946_2022.loc["mean"])*12



exStats1946_2022.loc["std"] = exStats1946_2022.loc["std"]*np.sqrt(12)
exStats1946_2022.loc["SR"] = exStats1946_2022.iloc[1]/exStats1946_2022.iloc[2]


exStats1946_2022.loc["skew"] = exReturns1946_2022.skew()
exStats1946_2022.loc["excessKurtosis"] = exReturns1946_2022.kurtosis()

#fjern rader vi ikke vil ha med i tabellen
exStats = exStats.drop(["count", "min", "25%","50%", "75%", "SR","max", "excessKurtosis"])
exStats1946_2022 = exStats1946_2022.drop(["count", "min", "25%","50%", "75%", "SR","max", "excessKurtosis"])
exStats1877_1945 = exStats1877_1945.drop(["count", "min", "25%","50%", "75%", "SR","max", "excessKurtosis"])

exStats = exStats.append(pd.Series(name="1877-1945"))
exStats = exStats.append(exStats1877_1945)
exStats = exStats.append(pd.Series(name="1945-2023"))
exStats = exStats.append(exStats1946_2022)
exStats = exStats.append(pd.Series(name="abs t-Stat (diff-in-mean"))

exStats = exStats[ ['exfutucom', 'exspotcom', '60/40', 'exequity', 'exbond', 'iracarry', 'Rf']]

tabel = exStats 
tabel.rename(columns = {"exfutucom":"Commodity Futures", "exspotcom":"Commodity Spot", "exequity":"Stocks", "exbond":"Bonds", "iracarry":"Interest rate-adjusted carry","Rf":"Short-Term Interest Rate"}, inplace = True)
tabel.rename( {"mean":"Arithmetic mean return","std":"Volatility", "skew":"Skewness", "geometric mean":"Geometric mean return"},inplace =True)


# endre til %
tabel.loc["Skewness"] = tabel.loc["Skewness"].round(2)
tabel.loc[["Arithmetic mean return", "Volatility","Geometric mean return" ]] = tabel.loc[["Arithmetic mean return", "Volatility", "Geometric mean return"]].mul(100).round(1).astype(str).add("%")
tabel = tabel.reset_index()

#print(tabulate(tabel, headers = "firstrow", tablefmt= "latex")) test av annen tabell


print(tabel.to_latex(index = False, multirow = True))















































